package RPM::Source::BundleImport::Perl::Eval;

use strict;
use warnings;

### hooks ###
use RPM::Source::BundleImport::Perl::Eval::CPAN; # contains CPANPLUS
use RPM::Source::BundleImport::Perl::Eval::Devel::AssertEXE;
use RPM::Source::BundleImport::Perl::Eval::Devel::CheckLib;
use RPM::Source::BundleImport::Perl::Eval::ExtUtils::AutoInstall;
use RPM::Source::BundleImport::Perl::Eval::ExtUtils::PkgConfig;
use RPM::Source::BundleImport::Perl::Eval::File::ShareDir::Install;
use RPM::Source::BundleImport::Perl::Eval::ExtUtils::H2PM;
BEGIN {
    $INC{'CPAN.pm'}='CPAN.pm';
    $INC{'CPANPLUS.pm'}='CPANPLUS.pm';
    # TODO: provide a stub
    # $INC{'CPANPLUS/Config.pm'}='CPANPLUS/Config.pm';
    $INC{'Devel/AssertEXE.pm'}='Devel/AssertEXE.pm';
    $INC{'Devel/CheckLib.pm'}='Devel/CheckLib.pm';
    $INC{'ExtUtils/AutoInstall.pm'}='ExtUtils/AutoInstall.pm';
    $INC{'ExtUtils/PkgConfig.pm'}='ExtUtils/PkgConfig.pm';
    $INC{'File/ShareDir/Install.pm'}='File/ShareDir/Install.pm';

    $INC{'inc/File/ShareDir/Install.pm'}='inc/File/ShareDir/Install.pm';
    $INC{'inc/Devel/AssertEXE.pm'}='inc/Devel/AssertEXE.pm';
    $INC{'inc/Devel/CheckLib.pm'}='inc/Devel/CheckLib.pm';
    $INC{'inc/ExtUtils/PkgConfig.pm'}='inc/ExtUtils/PkgConfig.pm';

    # TODO: used in <generator>.PL , not in Makefile.PL
    $INC{'ExtUtils/H2PM.pm'}='ExtUtils/H2PM.pm';
}

sub collected_data {
    return {
	# SourceAnalyzer stuff
	'perl' => \@CPAN::PERLINST,
	'path' => \@Devel::AssertEXE::exe,
	'libs' => \@Devel::CheckLib::libs,
	'hdrs' => [@Devel::CheckLib::headers, @ExtUtils::H2PM::headers],
	'pkgconf' => \@ExtUtils::PkgConfig::pkgconfig,
	# useful to detect /auto/share/ in %files
	'ShareDirInstallDirs' => \@File::ShareDir::Install::DIRS,
    };
}

# for multiple use
# call before re-use
sub clean {
    &CPAN::clean();
    &Devel::CheckLib::clean();
    &Devel::AssertEXE::clean();
    &ExtUtils::H2PM::clean();
    &ExtUtils::PkgConfig::clean();
    &File::ShareDir::Install::clean();
}

1;

