package #
Devel::CheckLib;

require Exporter;
our @ISA = qw(Exporter);
our @EXPORT = qw(assert_lib check_lib_or_exit check_lib);
our @libs;
our @headers;

sub clean {
    @libs=();
    @headers=();
}

sub add_LIBS {
    my $LIBS=shift;
    foreach my $arg (split(/\s+/, $LIBS)) {
	$arg=~s/\s*$//;
	if ($arg =~ s/^-l//) {
	    #print "ADDED: LIB: $arg\n";
	    push @libs, $arg;
        }
    }
}

sub check_lib_or_exit {
    my $arg={@_};
    my $lib=$arg->{'lib'};
    my $header=$arg->{'header'};
    if ($lib) {
	if (ref($lib)) {
	    push @libs, @$lib;
	} else {
	    push @libs, $lib;
	}
    }
    if ($header) {
	if (ref($header)) {
	    push @headers, map{&__unquote($_)} @$header;
	} else {
	    push @headers, map{&__unquote($_)} split (/\s+/,$header);
	}
    }
    if(defined($arg->{'LIBS'})) {
	add_LIBS($arg->{'LIBS'});
    }
}

*assert_lib=*check_lib_or_exit;
*check_lib=*check_lib_or_exit;

sub __unquote{
    local $_=shift;
    s/^["<]//;
    s/[">]$//;
    #print STDERR "__unquote=$_\n";
    return $_;
}

1;
