package RPM::Source::BundleImport::Perl::MetaDumpFork;

use strict;
use warnings;
use POSIX ":sys_wait_h";
use YAML::Any qw/LoadFile/;

our $TIMEOUT_IN_SECONDS = 5;

### TODO!!!
our $opt_eval_keep_pipes=1;

sub get_collected_data_and_meta {
    my ($unpack_path)=@_;

    my $pid;
#$SIG{'INT'} = \&my_SH;
#sub my_SH {
#    kill $pid;
#    $pid = undef;
#    $SIG{'INT'} = 'DEFAULT';
#};

    if ( not defined($pid=fork()) ) {
        die "Oops! fork failed.";
    } elsif ($pid == 0) {
	# for the child process ...
	# create new process group with the child's pid for all the children to inherit
	setpgrp;
	exec('/usr/bin/metadump-helper-perl-cpan2rpm', $unpack_path);
	die "Oops! exec of /usr/bin/metadump-helper-perl-cpan2rpm $unpack_path failed.";
    } else {
	# TODO: why not kill on alarm instead of this eval?
	eval {
	    local $SIG{ALRM} = sub { die "alarm\n" };
	    alarm($TIMEOUT_IN_SECONDS);
	    # do stuff that might timeout.
	    # TODO: waitpid?
	    wait();
	    alarm(0);
	};
	if ($@) {
	    # handle timeout condition.
	    ## if child is active ...
	    if ( kill( 0 => $pid) ) {
	        # just kills a process, not a group of processes
                #kill 9, $pid;
	        # kills a process group (includes children thanks to setpgrp above)
                kill -9, $pid;
		print STDERR "WARNING: killed metadump-helper-perl-cpan2rpm as it runs more then $TIMEOUT_IN_SECONDS seconds.\n";
		return;
	    }
	}
    }
    my $metadatafile=$unpack_path.'.metadump-cpan2rpm.yml';
    return if ! -e $metadatafile;
    return LoadFile($metadatafile);
}


1;

