package RPM::Source::BundleImport::Perl::Utils;

use strict;
use warnings;

use Pod::PlainText;

sub get_abstract_description_from_pod {
    my ($pm_from)=@_;
    my $pod = Pod::PlainText->new();
    my $from = readfile($pm_from) if defined $pm_from;
    return unless $from;
    my ($abstract,$description);
    # failsafe from garbage like: abstract: ~ in meta
    $abstract ||= $pod->interpolate($1)
	if $from =~ /=head\d\s+(?:NAME|PACKAGE).*?-\s*(.*?)$/ism;
    if ($from =~ /=head\d\s+DESCRIPTION\s+(.*?)=(head|cut)/ism) {
	$description ||= $pod->interpolate($1);
    } elsif ($from =~ /=head\d\s+SYNOPSIS\s+(.*?)=(head|cut)/ism) {
	$description ||= $pod->interpolate($1);
    }
    $description=substr($description, 0, 2040).'...'."\n" if $description and length($description)>2040;
    return ($abstract,$description);
}

sub update_metadata_abstract_description {
    my ($info,$abstract,$description)=@_;
    my $oldabstract=$info->{'abstract'};
    my $olddescription=$info->{'description'};
    # failsafe from garbage like: abstract: ~ in meta
    $info->{'abstract'}='' if $oldabstract and $oldabstract=~/^\s*\W+\s*$/;
    $info->{'description'}='' if $olddescription and $olddescription=~/^\s*\W+\s*$/;
    $info->{'abstract'} ||= $abstract;
    $info->{'description'} ||= $description;
}

#### TODO: sharethis!!!

sub readfile {
    my $file=shift;
    my $content = '';
    open my $fh, $file or do {
	warn "get_abstract_description_from_pod: Can't open $file: $!";
	return '';
    };
    {
	local $/;
	$content = <$fh>;
    }
    close $fh;
    return $content;
}


1;
